echo off
echo   Batch file to simplify compiling with Borland Turbo-C 2.0 TCC.EXE DOS compiler. 
echo TCMAKE [tcc-prog-dir] [filename] [-option] [-option]...
echo   ie. TCMAKE D:\M\TC ERIC30 -ms -Z      (Compile ERIC30.C with Small mem model..)
echo   (View this batch file for more info..)
if not exist %1\tcc.exe goto patherror
path %path%;%1
echo on
%1\tcc -I%1\include -L%1\lib %3 %4 %5 %6 %7 %8 %2.c
echo off
goto byebye

:patherror
echo The first parameter must be the path for TCC.EXE - "%1" is not correct.
rem To compile this program, You can download the Turbo-C 2.0 compiler from the Borland historic 
rem  compilers site. (See Wikipedia entry for Turbo-C for latest links..)
rem  It is a good idea to use 8.3 compatible filenames and paths (ie all names <= 8 chars) 
rem  when working with TCC 2.0..
rem
rem Syntax is: TCC [ options ] file[s]       * = default; -x- = turn switch x off
rem   -1      80186/286 Instructions          -A      Disable non-ANSI extensions
rem   -B      Compile via assembly            -C      Allow nested comments
rem   -Dxxx   Define macro                    -Exxx   Alternate assembler name
rem   -G      Generate for speed              -Ixxx   Include files directory
rem   -K      Default char is unsigned        -Lxxx   Libraries directory
rem   -M      Generate link map               -N      Check stack overflow
rem   -O      Optimize jumps                  -S      Produce assembly output
rem   -Uxxx   Undefine macro                  -Z      Optimize register usage
rem   -a      Generate word alignment         -c      Compile only
rem   -d      Merge duplicate strings         -exxx   Executable file name
rem   -f    * Floating point emulator         -f87    8087 floating point
rem   -gN     Stop after N warnings           -iN     Maximum identifier length N
rem   -jN     Stop after N errors             -k      Standard stack frame
rem   -lx     Pass option x to linker         -mc     Compact Model
rem   -mh     Huge Model                      -ml     Large Model
rem   -mm     Medium Model                    -ms   * Small Model
rem   -mt     Tiny Model                      -nxxx   Output file directory
rem   -oxxx   Object file name                -p      Pascal calls
rem   -r    * Register variables              -u    * Underscores on externs
rem   -v      Source level debugging          -w      Enable all warnings
rem   -wxxx   Enable warning xxx              -w-xxx  Disable warning xxx
rem   -y      Produce line number info        -zxxx   Set segment names

:byebye
rem
